Tue  08-08-95
Manual for Cut open programme PTT16

Summary
1.  All ZEBRA installations
2.  Organizational
3.  Normal code, relative form
4.  Entered on dialled location, key address on 36. Cuts open a
    number of points of a programme to be tested and can print
    information when encountering these marked points. For
    further information see "Action and use of programme".

Input of programme
1.  Normal entry. Beginning address is arbitrary and can be
    dialled.
2.  When, during input of programme,
    U5 = 0: programme will be a printing version.
    U5 = 1: programme wil be a punching version.
3.  When during input:
    U2 = 0:  programme will have octal ouput on second bit of
    mode number during later action.
    U2 = 1:  programme will have fraction output on second bit of
    mode number during later action.

Occupies
1   Location 36 and 718 locations from dialled beginning.

Action and use of programme.
    The programme to be cut open is entered into the machine. The
cut-open programme is started via 36. (36) = beginning address of
cut-open programme. Now a number of instr. in the programme to be
tested can be cut open (maximum 50.
When on starting at 36.
U2 = 1:  Restore all instr. previously cut open
U2 = 0:  restore nothing.

    The programme is now ready to accept data concerning points
to be cut open in two forms:
U3 = 0:   Read points from the dial, mode number from U1 to U5.
U3 = 1:   Read point and modes from tape. U3 must be set before
          starting at 36.
          When U3 = 0 the programme comes to a stop to accept
          points from the dial.

    A mode for printing must then be set up on U1 to U5 as
follows:
U1 = 1:   Print contents of reg. in instr. form
U2 = 1:      "      "     "  "   in octal or fraction form.
U3 = 1:      "      "     "  "   in integer form
U4 = 1    Print contentes of all reg. in form dependent on U1..U3
          Lay out of printing is:
          A overflow  --------  (---------) (---------)
          B carry     --------  (---------) (---------)
          15          --------  (---------) (---------)
           4          --------  (---------) (---------)
           .          .
          14          --------  (---------) (---------)
          address     instruction
When U1..U3 are all = 0, then:
U4 = 0:   print address only
U4 = 1:   print address and instr. No contents of registers.
U5 = 0:   Restore instruction after having printed.
U5 = 1:   Leave instruction cut open after passing.

The input of addresses to be cut open is as follows:
Dial (or read from tape) an address n followed by a register
address m (m = 4..15). This must be a register which is free
during the axecution of the instruction.
More instructions can be input immediately in the same way with
the same or another mode (U1 to U5 are read between the diallings
of n and m). The programme is safeguarded against dialling n
twice.
An instruction can be restored by dialling its address followed
by m = 0.
Restoring an instr. which has been restored before does not have
any effect.

When inputting from tape, the programme goes on reading as long
as U3 = 1. First the mode must be given in the form X000 to X031,
where the mode is composed of five binary bits, corresponding to
U1 to U5 in the following way
                U5   U4   U3   U2   U1
                16    8    4    2    1
E.g. the mode for printing A and B octal, non-restoring is X018).
The mode given once at the beginning of the tape applies to all
adresses following, until a new one is given.
The addresses are given in the form Xn.m where m is an available
register or 0. When no mode is given at the beginning of the tape
it will be X000.

     When all addresses to be cut open are loaded, the main
programme can be started in the usual way. No U keys are
used by the cut-open programme during action of the main
programme except U7. On encountering an instr. cut open, the
contents of the reg. are printed according to the mode for that
point.

When U7 is pressed, the printing of the contents of registers is
suppressed from thence and address (instr.) are printed.
When U7 is kept depressed until the end of instr., the programme
stops on a dial stop.
Two actions can follow:
Dialling a number 0 to 31 changes the mode for that instr. to the
dialled mode (U5 = 16 etc.). E.g. when mode 0 is dialled, the
breakpoint will be taken away immediately. No other modes below
16 make sense.
Dialling an address n and reg. m cuts open a new point. But first
specify the mode on U1 to U5 before dialling n. And restore U1 to
U5 to normal working order before dialling m.

Employs:
1.    A, B and all registers. However all previous contents are
      saved at the beginning and restored on leaving the cut-opn
      programme, except reg. m.
2.    Uses dial programme from NIP.
3.    Uses NOP
4.    Uses NIP for input of points by tape instr. when U3=1.

Timing
About 70ms + time for punching or printing.

Notes
1.    When an instruction of the form XK and NOT D, NOT E is cut
      open, the variable instruction following is automatically
      printed according to the mode. Of the XK Not D Not E itself
      only number (and instr.) are printed. The mode can only be
      changed on such an instruction with U7. Pressing U7 while
      printing the automatically cut-open instr. has no effect.
      The location of the automatic instr. is printed as 0.
2.    An instr. written as a constant on the drum, but executed a
      register may be cut open provided, that it is the first. to
      be cut open or that only one such a constant is cut open.
      Further cuttings of normal instr. may follow.
3.    No instr. on track 0 can be cut open.
4.    No instr's  of the form KE0, KE1, KE2, KE3, KE16..KE31,
      AK16..AK22, and LRKE15 may be cut open.
5.    No variable instr. may be cut open.
6.    No instr. which are used as a constant elsewhere may be cut
      open.
7.    All sorts of other instr. e.g. failing tests, A instr.,
      AK23, AK24, NK24, KEm, instr. with failing after action
      etc. may be cut open.

Acknowledgement
      This programme was devised and written by the Netherlands
PTT under the reference PTT16.
{Copyright Netherlands Postal & Telecommunications Services.
 PTT Research 1957-1967}

 
